export enum PrivilegeAction {
  VIEW = 'view',
  CREATE = 'create',
  EDIT = 'edit',
  DELETE = 'delete',
  CANCEL = 'cancel',
  CONFIRM = 'confirm',
}

export const PrivilegeAdminConstant = [
  {
    menu: 'DASHBOARD',
    menu_label: 'Dashboard',
    actions: [PrivilegeAction.VIEW],
    index: 1,
  },
  {
    menu: 'CALENDAR',
    menu_label: 'Kalender',
    actions: [PrivilegeAction.VIEW],
    index: 2,
  },
  {
    menu: 'BOOKING',
    menu_label: 'Pemesanan',
    actions: [
      PrivilegeAction.VIEW,
      PrivilegeAction.CREATE,
      PrivilegeAction.CONFIRM,
      PrivilegeAction.DELETE,
      PrivilegeAction.CANCEL,
      PrivilegeAction.EDIT,
    ],
    index: 3,
  },
  {
    menu: 'REFUND',
    menu_label: 'Pengembalian',
    actions: [
      PrivilegeAction.VIEW,
      PrivilegeAction.CREATE,
      PrivilegeAction.CONFIRM,
      PrivilegeAction.DELETE,
      PrivilegeAction.CANCEL,
      PrivilegeAction.EDIT,
    ],
    index: 4,
  },
  {
    menu: 'RECONCILIATION',
    menu_label: 'Rekonsiliasi',
    actions: [
      PrivilegeAction.VIEW,
      PrivilegeAction.CREATE,
      PrivilegeAction.CONFIRM,
      PrivilegeAction.DELETE,
      PrivilegeAction.CANCEL,
      PrivilegeAction.EDIT,
    ],
    index: 5,
  },
  {
    menu: 'ITEM',
    menu_label: 'Item',
    actions: [
      PrivilegeAction.VIEW,
      PrivilegeAction.CREATE,
      PrivilegeAction.EDIT,
      PrivilegeAction.DELETE,
    ],
    index: 6,
  },
  {
    menu: 'SEASON',
    menu_label: 'Season',
    actions: [
      PrivilegeAction.VIEW,
      PrivilegeAction.CREATE,
      PrivilegeAction.EDIT,
      PrivilegeAction.DELETE,
    ],
    index: 7,
  },
  {
    menu: 'USER',
    menu_label: 'Pengguna',
    actions: [
      PrivilegeAction.VIEW,
      PrivilegeAction.CREATE,
      PrivilegeAction.EDIT,
      PrivilegeAction.DELETE,
    ],
    index: 8,
  },
  {
    menu: 'TENANT',
    menu_label: 'Tenant',
    actions: [
      PrivilegeAction.VIEW,
      PrivilegeAction.CREATE,
      PrivilegeAction.EDIT,
      PrivilegeAction.DELETE,
    ],
    index: 9,
  },
  {
    menu: 'WEB_INFORMATION',
    menu_label: 'Informasi Web',
    actions: [
      PrivilegeAction.VIEW,
      PrivilegeAction.CREATE,
      PrivilegeAction.EDIT,
      PrivilegeAction.DELETE,
    ],
    index: 10,
  },
  {
    menu: 'SETTING',
    menu_label: 'Setting',
    actions: [
      PrivilegeAction.VIEW,
      PrivilegeAction.CREATE,
      PrivilegeAction.EDIT,
      PrivilegeAction.DELETE,
    ],
    index: 11,
  },
  {
    menu: 'REPORT',
    menu_label: 'Laporan',
    actions: [PrivilegeAction.VIEW],
    index: 12,
  },
  {
    menu: 'DISCOUNT_CODE',
    menu_label: 'Generate Diskon Kode',
    actions: [PrivilegeAction.CREATE],
    index: 13,
  },
];

export const PrivilegePOSConstant = [
  {
    menu: 'SALES',
    menu_label: 'Penjualan',
    actions: [
      PrivilegeAction.VIEW,
      PrivilegeAction.CREATE,
      PrivilegeAction.DELETE,
      PrivilegeAction.EDIT,
    ],
    index: 14,
  },
  {
    menu: 'QR_PRINT',
    menu_label: 'Print QR',
    actions: [PrivilegeAction.VIEW, PrivilegeAction.CREATE],
    index: 15,
  },
  {
    menu: 'BOOKING',
    menu_label: 'Pemesanan',
    actions: [PrivilegeAction.VIEW, PrivilegeAction.CREATE],
    index: 16,
  },
  {
    menu: 'WITHDRAW',
    menu_label: 'Penarikan Kas',
    actions: [PrivilegeAction.VIEW, PrivilegeAction.CREATE],
    index: 17,
  },
  {
    menu: 'POS_DISCOUNT_CODE',
    menu_label: 'Generate Diskon Kode',
    actions: [PrivilegeAction.CREATE],
    index: 18,
  },
];
