import { Injectable } from '@nestjs/common';
import { EventBus } from '@nestjs/cqrs';
const midtransClient = require('midtrans-client');

@Injectable()
export class MidtransService {
  constructor(private eventBus: EventBus) {}

  get midtransInstance() {
    return new midtransClient.Snap({
      isProduction: false,
      serverKey: process.env.MIDTRANS_SERVER_KEY,
      clientKey: process.env.MIDTRANS_CLIENT_KEY,
    });
  }

  async getStatus(orderId: string): Promise<any> {
    return await this.midtransInstance.transaction.status(orderId);
  }

  async create(body): Promise<any> {
    return await this.midtransInstance.createTransaction({
      transaction_details: {
        order_id: '123',
        gross_amount: 10000,
      },
      credit_card: {
        secure: true,
      },
      customer_details: {
        first_name: 'budd',
        last_name: 'pratama',
        email: 'budi.pra@mail.com',
        phone: '0822111111',
      },
    });
  }
}
