import {
  DATA_FORMAT,
  DATA_TYPE,
  FILTER_FIELD_TYPE,
  FILTER_TYPE,
  REPORT_GROUP,
} from '../../../constant';
import { ReportConfigEntity } from '../../../entities/report-config.entity';

export default <ReportConfigEntity>{
  group_name: REPORT_GROUP.transaction_report,
  unique_name: `${REPORT_GROUP.transaction_report}__income`,
  label: 'Pendapatan',
  table_schema: 'season_types main',
  main_table_alias: 'main',
  defaultOrderBy: [],
  lowLevelOrderBy: [],
  filter_period_config: {
    hidden: true,
  },

  column_configs: [
    {
      column: 'main__created_at',
      query: 'main.created_at',
      label: 'Created Date',
      type: DATA_TYPE.DIMENSION,
      format: DATA_FORMAT.DATE_EPOCH,
    },
    {
      column: 'main__updated_at',
      query: 'main.updated_at',
      label: 'Updated Date',
      type: DATA_TYPE.DIMENSION,
      format: DATA_FORMAT.DATE_EPOCH,
    },
    {
      column: 'main__name',
      query: 'main.name',
      label: 'Name',
      type: DATA_TYPE.DIMENSION,
      format: DATA_FORMAT.TEXT,
    },
  ],
  filter_configs: [
    {
      filed_label: 'Name',
      filter_column: 'main__name',
      field_type: FILTER_FIELD_TYPE.select,
      filter_type: FILTER_TYPE.TEXT_IN_MEMBER,
      select_data_source_url: '/v1/season-types',
      select_custom_options: [],
      select_label_key: 'name',
      select_value_key: 'name',
    },
    {
      filed_label: 'Status',
      filter_column: 'main__status',
      field_type: FILTER_FIELD_TYPE.input_text,
      filter_type: FILTER_TYPE.TEXT_EQUAL,
      // select_data_source_url: '/v1/season-types',
      // select_custom_options: [],
      // select_label_key: 'code',
      // select_value_key: 'code',
    },
  ],
};
