import {
  generateCodeDate,
  generateRandom,
} from 'src/modules/transaction/vip-code/domain/usecases/managers/helpers/generate-random.helper';
import { ILike } from 'typeorm';

export async function generateInvoiceCodeHelper(dataService) {
  const month_year = generateCodeDate();
  const char = generateRandom(1);
  const number = generateRandom(1, true);

  const invoice_code = await dataService.getManyByOptions({
    where: {
      invoice_code: ILike(`%${month_year}%`),
    },
  });
  const current_number = invoice_code.length + 1;

  return `INV-${month_year}${char}${number}/${current_number
    .toString()
    .padStart(5, '0')}`;
}
