import { BaseStatusDto } from 'src/core/modules/infrastructure/dto/base-status.dto';
import { FaqEntity } from '../../domain/entities/faq.entity';
import { IsString } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class FaqDto extends BaseStatusDto implements FaqEntity {
  @ApiProperty({
    type: String,
    required: true,
    example: 'Booking',
  })
  @IsString()
  title: string;

  @ApiProperty({
    type: String,
    required: false,
    example: 'Booking descs',
  })
  description: string;
}
